library IniExpo;

uses ReadIni;

{$G READINI, OBJECTS, MEMORY, DOS, HISTORY, ADVUTIL, OBJUTIL}
{$D Read configuration from *.INI file}

function NextChar : char; export;
  begin
    NextChar := ReadIni.NextChar;
  end;

function EndIniFile : boolean; export;
  begin
    EndIniFile := ReadIni.EndIniFile;
  end;

exports
  OpenIniFile         index 1,
  CloseIniFile        index 2,
  GetIniError         index 3,
{$IFDEF INCLUDE}
  SetIncludePath      index 4,
{$ENDIF}
  EndIniFile          index 5,

  SearchSection       index 10,
  SearchKey           index 11,
  GetKey              index 12,
  InitGetSection      index 13,
  GetSection          index 14,

  GetInteger          index 20,
  GetFloat            index 21,
  GetStatementNumber  index 22,
  GetString           index 23,
  GetQuoteString      index 24,
  GetBoolean          index 25,
  GetLine             index 26,

  Blanks              index 30,
  ReadWord            index 31,
  ReadString          index 32,
  ReadChar            index 33,
  ReadNumeric         index 34,
  ReadStr             index 35,
  CheckStatement      index 36,
  GetStatement        index 37,
  NextChar            index 38,
  ReadWordDelim       index 39,
  ReadPhrase          index 40;

begin
end.
