unit Inlines;

interface

function MaxInt(A,B : integer) : integer;
inline(
   $58/     {pop   ax   }
   $5B/     {pop   bx   }
   $3B/$C3/ {cmp   ax,bx}
   $7F/$01/ {jg    @@1  }
   $93);    {xchg  ax,bx}
       {@@1:            }

function MinInt(A,B : integer) : integer;
inline(
   $58/     {pop   ax   }
   $5B/     {pop   bx   }
   $3B/$C3/ {cmp   ax,bx}
   $7C/$01/ {jl    @@1  }
   $93);    {xchg  ax,bx}
       {@@1:            }

function MaxWord(A,B : word) : word;
inline(
   $58/     {pop   ax   }
   $5B/     {pop   bx   }
   $3B/$C3/ {cmp   ax,bx}
   $77/$01/ {ja    @@1  }
   $93);    {xchg  ax,bx}
       {@@1:            }

function MinWord(A,B : word) : word;
inline(
   $58/     {pop   ax   }
   $5B/     {pop   bx   }
   $3B/$C3/ {cmp   ax,bx}
   $72/$01/ {jb    @@1  }
   $93);    {xchg  ax,bx}
       {@@1:            }


function RangeInt(Val,Min,Max : integer) : integer;
inline(
  $5A/      {    pop   ax    }
  $5B/      {    pop   bx    }
  $58/      {    pop   dx    }
  $39/$D8/  {    cmp   ax, bx}
  $7F/$03/  {    jg    @1    }
  $93/      {    xchg  ax, bx}
  $EB/$05/  {    jmp   @2    }
  $39/$D0/  {@1: cmp   ax, dx}
  $7C/$01/  {    jl    @2    }
  $92);     {    xchg  ax, dx}
            {@2:             }

function RangeWord(Val,Min,Max : word) : word;
inline(
  $5A/      {    pop   ax    }
  $5B/      {    pop   bx    }
  $58/      {    pop   dx    }
  $39/$D8/  {    cmp   ax, bx}
  $77/$03/  {    ja    @1    }
  $93/      {    xchg  ax, bx}
  $EB/$05/  {    jmp   @2    }
  $39/$D0/  {@1: cmp   ax, dx}
  $72/$01/  {    jb    @2    }
  $92);     {    xchg  ax, dx}
            {@2:             }


function SwapWord(L : longint) : longint;
inline(
  $5A/      {pop  dx}
  $58);     {pop  ax}

function SwapLong(L : longint) : longint;
inline(
  $5A/      {pop  dx    }
  $58/      {pop  ax    }
  $86/$E0/  {xchg al, ah}
  $86/$F2); {xchg dl, dh}


function Equals(var Source,Dest; Count : word) : boolean;
inline(
  $59/      {    pop   cx    }
  $5F/      {    pop   di    }
  $07/      {    pop   es    }
  $5E/      {    pop   si    }
  $58/      {    pop   ax    }
  $1E/      {    push  ds    }
  $8E/$D8/  {    mov   ds, ax}
  $FC/      {    cld         }
  $33/$C0/  {    xor   ax, ax}
  $F3/$A6/  {    repe  cmpsb }
  $75/$01/  {    jne   @@1   }
  $40/      {    inc   ax    }
  $1F);     {@@1:pop   ds    }


procedure FillLong(var Buf; Size : word; Value : longint);
inline(
  $5866/        {   pop   eax   }
  $59/          {   pop   cx    }
  $5F/          {   pop   di    }
  $07/          {   pop   es    }
  $08E3/        {   jcxz  @@2   }
  $FC/          {   cld         }
  $F3/$66/$AB); {   rep   stosd }
                {@@2:           }

procedure FillWord(var Buf; Size,Value : word);
inline(
  $58/          {   pop   ax    }
  $59/          {   pop   cx    }
  $5F/          {   pop   di    }
  $07/          {   pop   es    }
  $08E3/        {   jcxz  @@2   }
  $FC/          {   cld         }
  $F3/$AB);     {   rep   stosw }
                {@@2:           }


function CharPos(C : char; S : string) : byte;
inline(
  $5F/          {   pop   di          }
  $07/          {   pop   es          }
  $58/          {   pop   ax          }
  $ED30/        {   xor   ch, ch      }
  $26/$8A/$0D/  {   mov   cl, es:[di] }
  $CC88/        {   mov   ah, cl      }
  $47/          {   inc   di          }
  $AEF2/        {   repne scasb       }
  $0474/        {   je    @@1         }
  $C031/        {   xor   ax, ax      }
  $04EB/        {   jmp   @@2         }
                {@@1:                 }
  $CC28/        {   sub   ah, cl      }
  $E088);       {   mov   al, ah      }
                {@@2:                 }


implementation

end.
